Option Strict Off
Option Explicit On

Imports System.IO
Imports System.Threading
Imports System.Drawing.Drawing2D

Module VbScreen

    Public ScreenWidth As Long = 640
    Public ScreenHeight As Long = 480
    Public ScreenRect As New Rectangle(0, 0, ScreenWidth, ScreenWidth)

    ' Actual scaled width and height
    Public ScaledWidth As Double = ScreenWidth
    Public ScaledHeight As Double = ScreenHeight
    Public ScaledTransform As New Matrix()

    Public context As BufferedGraphicsContext = BufferedGraphicsManager.Current
    Public Speed As Short = 1
    Public Pic(1) As Image

    Public BackColor As Color
    Public MenuFont As Font
    Public GameFont As Font

    Dim Tell As Short
    Dim CurrentSelect As Short

    Public Function EndreSkjermStrrelse() As Object
        Dim context As BufferedGraphicsContext = BufferedGraphicsManager.Current
        context.MaximumBuffer = Screen.PrimaryScreen.Bounds.Size

        BackColor = Color.Aqua

        ' Initialize font
        MenuFont = Form1.Font
        MenuFont = VB6.FontChangeName(MenuFont, "Times New Roman")
        MenuFont = VB6.FontChangeSize(MenuFont, 36)

        GameFont = MenuFont
        GameFont = VB6.FontChangeSize(MenuFont, 24)

        'PicDesc.lWidth = 160
        'PicDesc.lHeight = 320
        Pic(0) = Image.FromFile(GetResourcePath("Ting.png"))

        '
        'PicDesc.lHeight = 32
        Pic(1) = Image.FromFile(GetResourcePath("Ani.png"))

        ' Load WAV
        LoadWAV("box.wav")
        LoadWAV("jingle.wav")
        LoadWAV("nothing.wav")

    End Function

    Public Function Clean() As Object

        mciSendString("close " & Chr(34) & GetResourcePath("bomber.mid") & Chr(34), Nothing, 0, 0)
        UnloadWAV()

        ' Clear images
        For Each img As Image In Pic
            If Not img Is Nothing Then
                img.Dispose()
            End If
        Next

        End

    End Function

    Public Function GetResourcePath(ByVal fileName As String) As String
        Return Path.Combine(My.Application.Info.DirectoryPath, "Resources\" & fileName)
    End Function

    Public Function GetLevelPath(ByVal levelName As String) As String
        Return Path.Combine(My.Application.Info.DirectoryPath, "Levels\" & levelName)
    End Function

    Public Sub UpdateScale(newSize As Rectangle)

        ' Do not scale beyond the primary screen size
        Dim maxSize As Size = Screen.PrimaryScreen.Bounds.Size

        Dim scaleX As Double = Math.Min(newSize.Width, maxSize.Width) / ScreenWidth
        Dim scaleY As Double = Math.Min(newSize.Height, maxSize.Height) / ScreenHeight
        Dim scale As Double = Math.Min(scaleX, scaleY)

        Dim transform As New Matrix()
        transform.Scale(scale, scale)

        ' Now update the scale
        ScaledWidth = ScreenWidth * scale
        ScaledHeight = ScreenHeight * scale
        ScaledTransform = transform

    End Sub

    Public Sub Start()

        Dim Key(4) As Short
        Dim B As Short

        If GameOver = False Then B = 1 Else B = 0

            Do While Not ExitGame
                Using buffer As BufferedGraphics = context.Allocate(Form1.CreateGraphics(), New Rectangle(0, 0, ScaledWidth, ScaledHeight))
                buffer.Graphics.Transform = ScaledTransform
                buffer.Graphics.FillRectangle(New SolidBrush(BackColor), ScreenRect)
                DrawStart(buffer.Graphics)

                If GetKeyState(System.Windows.Forms.Keys.Down) < 0 Then
                    If Key(0) = 0 Then
                        Key(0) = 1
                        CurrentSelect = CurrentSelect + 1
                        If CurrentSelect = 4 + B Then CurrentSelect = 0
                    End If
                Else
                    Key(0) = 0
                End If

                If GetKeyState(System.Windows.Forms.Keys.Up) < 0 Then
                    If Key(1) = 0 Then
                        Key(1) = 1
                        CurrentSelect = CurrentSelect - 1
                        If CurrentSelect = -1 Then CurrentSelect = 3 + B
                    End If
                Else
                    Key(1) = 0
                End If

                If CurrentSelect = 1 + B Or CurrentSelect = 2 + B Then
                    If GetKeyState(System.Windows.Forms.Keys.Left) < 0 Then
                        If Key(2) = 0 Then
                            Key(2) = 1
                            If Not Speed = 0 And CurrentSelect = 1 + B Then Speed = Speed - 1
                            If CurrentSelect = 2 + B Then Sound = Not Sound
                        End If
                    Else
                        Key(2) = 0
                    End If

                    If GetKeyState(System.Windows.Forms.Keys.Right) < 0 Then
                        If Key(3) = 0 Then
                            Key(3) = 1
                            If Not Speed = 50 And CurrentSelect = 1 + B Then Speed = Speed + 1
                            If CurrentSelect = 2 + B Then Sound = Not Sound
                        End If
                    Else
                        Key(3) = 0
                    End If
                End If

                If GetKeyState(13) < 0 Then
                    If Key(4) = 0 Then
                        Key(4) = 1
                        If GameOver = True Then
                            If CurrentSelect = 0 + B Then Exit Do
                            If CurrentSelect = 3 + B Then Clean()
                        Else
                            If CurrentSelect = 0 Then Igjen = True : Exit Do
                            If CurrentSelect = 0 + B Then Exit Do
                            If CurrentSelect = 3 + B Then Clean()
                        End If
                    End If
                Else
                    Key(4) = 0
                End If

                System.Windows.Forms.Application.DoEvents()
                buffer.Render(Form1.CreateGraphics())

                Thread.Sleep(30)

            End Using
        Loop

    End Sub

    Private Sub DrawStart(ByVal g As Graphics)

        Tell = 0

        If GameOver = False Then PrintText(g, "Resume", MenuFont)
        PrintText(g, "New Game", MenuFont)
        PrintText(g, "Speed: " & Speed, MenuFont)
        PrintText(g, "Sound: " & Sound, MenuFont)
        PrintText(g, "End", MenuFont)

    End Sub

    Private Sub PrintText(ByVal g As Graphics, ByRef Text As String, ByVal font As Font)
        Tell = Tell + 1

        Dim brush As Brush = IIf(Tell - 1 = CurrentSelect, Brushes.Red, Brushes.Black)

        Dim x As Integer = (ScreenWidth / 2) - (TextWidth(g, font, Text) / 2)
        Dim y As Integer = (ScreenHeight / 2) - ((2 - Tell) * TextHeight(g, font, "A")) - 36

        g.DrawString(Text, font, brush, x, y)

    End Sub
End Module